using System;
using Gtk;

public partial class MainWindow : Gtk.Window
{
	int focus = 1;
	
	public MainWindow () : base(Gtk.WindowType.Toplevel)
	{
		Build ();
	}

	protected void OnDeleteEvent (object sender, DeleteEventArgs a)
	{
		Application.Quit ();
		a.RetVal = true;
	}
	
	protected void foco()
	{
		if (focus == 1 )
		{			
			label1.Text="<b>"+label1.Text+"</b>";
			label2.Text=label2.Text;
			label1.UseMarkup = true;
			label2.UseMarkup = false;
		}
		
		if (focus == 2 )
		{
			label2.Text="<b>"+label2.Text+"</b>";
			label1.Text=label1.Text;
			label1.UseMarkup = false;
			label2.UseMarkup = true;
		}
	}
		
	protected virtual void OnButtonNumericClicked (object sender, System.EventArgs e)
	{		
		if (focus == 1)
		{
			if (label1.Text == "0")
				label1.Text = "";
		
			label1.Text += (sender as Button).Label;
		}
		
		if (focus == 2)
		{
			if (label2.Text == "0")
				label2.Text = "";
		
			label2.Text += (sender as Button).Label;
		}
		
		foco();
		Console.WriteLine("Boton {0} Pulsado",(sender as Button).Label);
	}
	
	protected virtual void OnButtonOperationClicked (object sender, System.EventArgs e)
	{	
		if (label_operator.Text == "")
			label_operator.Text =  "+";		
		else if (label_operator.Text == "+")
			  label_operator.Text = "-";
		else if (label_operator.Text == "-")
			  label_operator.Text = "*";
		else if (label_operator.Text == "*")
			  label_operator.Text = "/";
		else if (label_operator.Text == "/")
			  label_operator.Text = "+";
		
		focus = 2;
		
		foco();
		Console.WriteLine("Boton {0} Pulsado ({1})",(sender as Button).Label,label_operator.Text);
	}
		
	protected virtual void OnButtonfocusClicked (object sender, System.EventArgs e)
	{
		if ( (sender as Button) == buttonfocus1 )
			focus=1;
		else if ( (sender as Button) == buttonfocus2 )
			focus=2;
		
		foco();
	}
	
	protected virtual void OnButtonResultClicked (object sender, System.EventArgs e)
	{
		decimal resultado = decimal.Parse(label1.Text);
		int i=2;
		
		if (label_operator.Text == "")
			label2.Text = "0";		
		else if (label_operator.Text == "+")
			resultado+=decimal.Parse(label2.Text);
		else if (label_operator.Text == "-")
			resultado-=decimal.Parse(label2.Text);
		else if (label_operator.Text == "*")
			resultado*=decimal.Parse(label2.Text);
		else if (label_operator.Text == "/")
			resultado/=decimal.Parse(label2.Text);
		
		if (resultado%1==0) i=0;
		resultado = decimal.Round(resultado,i);
		
		label1.Text=resultado.ToString();
		label2.Text="0";
		
		focus=2;
		
		foco();		
		Console.WriteLine("{0} {1} {2} = {3}",label1.Text,label_operator.Text,label2.Text,resultado);		
	}
	
	protected virtual void OnButtondeleteClicked (object sender, System.EventArgs e)
	{
		if ( (sender as Button) == buttondeleteline )
		{
			if (focus == 1)
				label1.Text="0";
			else if (focus == 2)
				label2.Text="0";
		}
		
		else if ( (sender as Button) == buttondeleteall )
		{
			label1.Text="0";
			label2.Text="0";
			label_operator.Text="+";
			focus = 1;
		}
		
		else if ( (sender as Button) == buttondelete )
		{
			string aux="";
			
			if (focus == 1)
			{
				for (int i=0; i<label1.Text.Length-1; i++)
					aux+=label1.Text[i];
			
				if (aux=="") aux = "0";
				label1.Text = aux;
			}
			
			if (focus == 2)
			{
				for (int i=0; i<label2.Text.Length-1; i++)
					aux+=label2.Text[i];
			
				if (aux=="") aux = "0";
				label2.Text = aux;
			}
			
			
		}
		
		foco();		
	}
	
}

